<template>
  <div class="execution">

    <basic-container>
      <avue-crud ref="crud"
                 :page="page"
                 :data="tableData"
                 :permission="permissionList"
                 :table-loading="tableLoading"
                 :option="tableOption"
                 @on-load="getList"
                 @search-change="searchChange"
                 @refresh-change="refreshChange"
                 @size-change="sizeChange"
                 @current-change="currentChange"
                 @row-update="handleUpdate"
                 @row-save="handleSave">
      </avue-crud>
    </basic-container>
  </div>
</template>

<script>
  import {selectwmDaProjectList, updateWmDaProjectById, insertWmDaProject, selectProjects} from '@/api/wmdaproject'
  import {tableOptionZb} from '@/const/crud/wmdaproject'
  import {mapGetters} from 'vuex'

  export default {
    name: 'wmdaproject',
    data() {
      return {
        searchForm: {},
        tableData: [],
        page: {
          total: 0, // 总页数
          currentPage: 1, // 当前页数
          pageSize: 20 // 每页显示多少条
        },
        tableLoading: false,
        tableOption: tableOptionZb,
      }
    },
    computed: {
      ...mapGetters(['permissions', 'userInfo']),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permissions.admin_wmdaproject_add, true),
          delBtn: this.vaildData(this.permissions.admin_wmdaproject_search, false),
          editBtn: this.vaildData(this.permissions.admin_wmdaproject_edit, true)
        };
      }
    },
    methods: {
      getList(page, params) {
        this.searchForm.typeid = 4;
        // let roles=this.userInfo.roles;
        // for(var i =0;i<roles.length;i++)
        // {
        //   if(3==roles[i])
        //   {
        //     this.searchForm.drugEntId=this.userInfo.drugEntId;
        //   }
        // }
        this.tableLoading = true
        selectwmDaProjectList(Object.assign({
          current: page.currentPage,
          size: page.pageSize
        }, params, this.searchForm)).then(response => {
          this.tableData = response.data.data.records
          this.page.total = response.data.data.total
          this.tableLoading = false
        }).catch(() => {
          this.tableLoading = false
        })
      },
      handleUpdate: function (row, index, done, loading) {

        updateWmDaProjectById(row).then(data => {
          this.$message.success('修改成功')
          done()
          this.getList(this.page)
        }).catch(() => {
          loading();
        });
      },
      handleSave: function (row, done, loading) {
        insertWmDaProject(row).then(data => {
          this.$message.success('添加成功')
          done()
          this.getList(this.page)
        }).catch(() => {
          loading();
        });
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize
      },
      currentChange(current) {
        this.page.currentPage = current
      },
      searchChange(form, done) {
        this.searchForm = form
        this.page.currentPage = 1
        this.getList(this.page, form)
        done()
      },
      refreshChange() {
        this.getList(this.page)
      }
    }
  }
</script>
